<?php
/*
*	Yandex.Maps plugin for Livestreet CMS
*	Developer: Igor Klochko
*   Contact e-mail: klochko.igor@gmail.com
*/

class PluginYmap_ActionYmap extends ActionPlugin {
	protected $sUserLogin=null;

	public function Init() {
	}
	/**
	 * Регистрируем евенты
	 *
	 */
	protected function RegisterEvent() {
		$this->AddEvent('admin','EventAdmin');
		$this->AddEventPreg('/^[\w\-\_]*$/i','EventShowYmap');
	}


	/**********************************************************************************
	************************ РЕАЛИЗАЦИЯ ЭКШЕНА ***************************************
	**********************************************************************************
	*/

	/**
	 * Отображение маркеров
	 *
	 * @return unknown
	 */
	protected function EventShowYmap() {
		if (!$this->sCurrentEvent) {
		
		$oOptions=$this->PluginYmap_Ymapoptions_GetYmapoptions();
		
		$this->Viewer_AddHtmlTitle($oOptions->getPagetitle());
		
		/**
		 * Получаем и загружаем список настроек
		 */
		 
		$aOptions=$this->PluginYmap_Ymapoptions_GetYmapoptions();
		if (count($aOptions)==0) {
			$aOptions=$this->PluginYmap_Ymapoptions_GetYmapoptions();
		}
		$this->Viewer_Assign('aOptions',$aOptions);
		
		/**
		 * Получаем и загружаем список всех маркеров
		 */
		$aMarkers=$this->PluginYmap_Ymap_GetMarkers();
		if (count($aMarkers)==0 and $this->PluginYmap_Ymap_GetCountMarker()) {
			$aMarkers=$this->PluginYmap_Ymap_GetMarkers();
		}
		$this->Viewer_Assign('aMarkers',$aMarkers);

		/**
		 * Устанавливаем шаблон для вывода
		 */		
		 
		if ($oOptions->getMapprovider()) {
		
			$this->SetTemplateAction('map');
		
		} else {
		
			/**
			* Получаем и загружаем список всех категорий маркеров
			*/
			$aMarkercats=$this->PluginYmap_Ymapcat_GetMarkercats();
			if (count($aMarkercats)==0 and $this->PluginYmap_Ymapcat_GetCountMarkercat()) {
				$aMarkercats=$this->PluginYmap_Ymapcat_GetMarkercats();
			}
			$this->Viewer_Assign('aMarkercats',$aMarkercats);
		
			$this->SetTemplateAction('gmap');
		
		}
		
		}
		
	}

	/**
	 * Админка карты
	 *
	 */
	protected function EventAdmin() {
		/**
		 * Если пользователь не авторизован и не админ, то выкидываем его
		 */
		$this->oUserCurrent=$this->User_GetUserCurrent();
		if (!$this->oUserCurrent or !$this->oUserCurrent->isAdministrator()) {			
			return $this->EventNotFound();
		}
		
		$this->Viewer_AddHtmlTitle($this->Lang_Get('marker_admin'));
		
		/** НАСТРОЙКИ **
		 * Обработка редактирования настроек
		 */
		/**
		 * Получаем и загружаем список настроек
		 */
		 
		$aOptions=$this->PluginYmap_Ymapoptions_GetYmapoptions();
		if (count($aOptions)==0) {
			$aOptions=$this->PluginYmap_Ymapoptions_GetYmapoptions();
		}
		$this->Viewer_Assign('aOptions',$aOptions);
		
		$oOptionsEdit=$this->PluginYmap_Ymapoptions_GetYmapoptions();
		
		if ($this->GetParam(0)=='options') {

				if (!isPost('submit_options_save')) {
					$_REQUEST['ymap_mapprovider']=$oOptionsEdit->getMapprovider();
					$_REQUEST['ymap_key']=$oOptionsEdit->getKey();
					$_REQUEST['ymap_width']=$oOptionsEdit->getWidth();
					$_REQUEST['ymap_height']=$oOptionsEdit->getHeight();
					$_REQUEST['ymap_center']=$oOptionsEdit->getCenter();
					$_REQUEST['ymap_zoom']=$oOptionsEdit->getZoom();
					$_REQUEST['ymap_pagetitle']=$oOptionsEdit->getPagetitle();
					$_REQUEST['ymap_enablescrollzoom']=$oOptionsEdit->getEnablescrollzoom();
					$_REQUEST['ymap_showtoolbar']=$oOptionsEdit->getShowtoolbar();
					$_REQUEST['ymap_showtypecontrol']=$oOptionsEdit->getShowtypecontrol();
					$_REQUEST['ymap_showzoom']=$oOptionsEdit->getShowzoom();	
					$_REQUEST['ymap_showsearchcontrol']=$oOptionsEdit->getShowsearchcontrol();	
					$_REQUEST['ymap_showsearch']=$oOptionsEdit->getShowsearch();						
				}	else {
					/**
					 * Если отправили форму с редактированием, то обрабатываем её
					 */
					$this->SubmitEditOptions($oOptionsEdit);
				}
				$this->Viewer_Assign('oOptionsEdit',$oOptionsEdit);
			
		}
		
		/** МАРКЕРЫ **
		 * Обработка создания нового маркера
		 */
		if (isPost('submit_marker_save')) {
			if (!getRequest('marker_id')) {
				$this->SubmitAddMarker();
			}
		}
		/**
		 * Обработка показа странички для редактирования маркера
		 */
		if ($this->GetParam(0)=='edit') {
			if ($oMarkerEdit=$this->PluginYmap_Ymap_GetMarkerById($this->GetParam(1))) {
				if (!isPost('submit_marker_save')) {
					$_REQUEST['marker_name']=$oMarkerEdit->getName();
					$_REQUEST['marker_latitude']=$oMarkerEdit->getLatitude();
					$_REQUEST['marker_longitude']=$oMarkerEdit->getLongitude();
					$_REQUEST['marker_cat']=$oMarkerEdit->getCat();
					$_REQUEST['marker_address']=$oMarkerEdit->getAddress();
					$_REQUEST['marker_phone']=$oMarkerEdit->getPhone();
					$_REQUEST['marker_link']=$oMarkerEdit->getLink();
					$_REQUEST['marker_image']=$oMarkerEdit->getImage();	
					$_REQUEST['marker_active']=$oMarkerEdit->getActive();	
					$_REQUEST['marker_id']=$oMarkerEdit->getId();						
				}	else {
					/**
					 * Если отправили форму с редактированием, то обрабатываем её
					 */
					$this->SubmitEditMarker($oMarkerEdit);
				}
				$this->Viewer_Assign('oMarkerEdit',$oMarkerEdit);
			} else {
				$this->Message_AddError($this->Lang_Get('marker_edit_notfound'),$this->Lang_Get('error'));
				$this->SetParam(0,null);
			}
		}
		/**
		 * Обработка удаления маркера
		 */
		if ($this->GetParam(0)=='delete') {
			$this->Security_ValidateSendForm();
			if ($this->PluginYmap_Ymap_deleteMarkerById($this->GetParam(1))) {
				$this->Message_AddNotice($this->Lang_Get('marker_admin_action_delete_ok'));
			} else {
				$this->Message_AddError($this->Lang_Get('marker_admin_action_delete_error'),$this->Lang_Get('error'));
			}
		}

		/**
		 * Получаем и загружаем список всех маркеров
		 */
		$aMarkers=$this->PluginYmap_Ymap_GetMarkers();
		if (count($aMarkers)==0 and $this->PluginYmap_Ymap_GetCountMarker()) {
			$aMarkers=$this->PluginYmap_Ymap_GetMarkers();
		}
		$this->Viewer_Assign('aMarkers',$aMarkers);
		
		
		/** 
		* Управление категориями маркеров
		*/
		
		/**
		 * Обработка создания новой категории маркера
		 */
		if (isPost('submit_markercat_save')) {
			if (!getRequest('cat_id')) {
				$this->SubmitAddMarkercat();
			}
		}
		
		/**  КАТЕГОРИИ МАРКЕРОВ **
		 *
		 * Обработка показа странички для редактирования категории маркеров
		 */
		if ($this->GetParam(0)=='editcat') {
			if ($oMarkercatEdit=$this->PluginYmap_Ymapcat_GetMarkercatById($this->GetParam(1))) {
				if (!isPost('submit_markercat_save')) {
					$_REQUEST['cat_name']=$oMarkercatEdit->getCatname();
					$_REQUEST['cat_stylename']=$oMarkercatEdit->getCatstylename();
					$_REQUEST['cat_icon']=$oMarkercatEdit->getCaticon();	
					$_REQUEST['cat_id']=$oMarkercatEdit->getCatid();						
				}	else {
					/**
					 * Если отправили форму с редактированием, то обрабатываем её
					 */
					$this->SubmitEditMarkercat($oMarkercatEdit);
				}
				$this->Viewer_Assign('oMarkercatEdit',$oMarkercatEdit);
			} else {
				$this->Message_AddError($this->Lang_Get('marker_edit_notfound'),$this->Lang_Get('error'));
				$this->SetParam(0,null);
			}
		}
		/**
		 * Обработка удаления категории маркеров
		 */
		if ($this->GetParam(0)=='deletecat') {
			$this->Security_ValidateSendForm();
			if ($this->PluginYmap_Ymapcat_deleteMarkercatById($this->GetParam(1))) {
				$this->Message_AddNotice($this->Lang_Get('cat_admin_action_delete_ok'));
			} else {
				$this->Message_AddError($this->Lang_Get('cat_admin_action_delete_error'),$this->Lang_Get('error'));
			}
		}

		/**
		 * Получаем и загружаем список всех категорий маркеров
		 */
		$aMarkercats=$this->PluginYmap_Ymapcat_GetMarkercats();
		if (count($aMarkercats)==0 and $this->PluginYmap_Ymapcat_GetCountMarkercat()) {
			$aMarkercats=$this->PluginYmap_Ymapcat_GetMarkercats();
		}
		$this->Viewer_Assign('aMarkercats',$aMarkercats);
	
	}
		
	/**
	 * Обработка отправки формы при редактировании маркера
	 *
	 * @param unknown_type $oMarkerEdit
	 */
	protected function SubmitEditMarker($oMarkerEdit) {
		
		/**
		 * Обновляем свойства маркера
		 */		
		$oMarkerEdit->setActive(getRequest('marker_active') ? 1 : 0);
		
		$oMarkerEdit->setName(getRequest('marker_name'));
		$oMarkerEdit->setLatitude(getRequest('marker_latitude'));
		$oMarkerEdit->setLongitude(getRequest('marker_longitude'));
		$oMarkerEdit->setCat(getRequest('marker_cat'));
		$oMarkerEdit->setAddress(getRequest('marker_address'));
		$oMarkerEdit->setPhone(getRequest('marker_phone'));
		$oMarkerEdit->setLink(getRequest('marker_link'));
		$oMarkerEdit->setImage(getRequest('marker_image'));
		/**
		 * Обновляем маркер
		 */
		if ($this->PluginYmap_Ymap_UpdateMarker($oMarkerEdit)) {
			$this->Message_AddNotice($this->Lang_Get('marker_edit_submit_save_ok'));
			$this->SetParam(0,null);
			$this->SetParam(1,null);
		} else {
			$this->Message_AddError($this->Lang_Get('system_error'));
		}
	}
	
	/**
	 * Обработка отправки формы при редактировании Настроек
	 */
	protected function SubmitEditOptions($oOptionsEdit) {
		
		/**
		 * Обновляем настройки
		 */		
		
		$oOptionsEdit->setMapprovider(getRequest('ymap_mapprovider')  ? 1 : 0);
		$oOptionsEdit->setKey(getRequest('ymap_key'));
		$oOptionsEdit->setWidth(getRequest('ymap_width'));
		$oOptionsEdit->setHeight(getRequest('ymap_height'));
		$oOptionsEdit->setCenter(getRequest('ymap_center'));
		$oOptionsEdit->setZoom(getRequest('ymap_zoom'));
		$oOptionsEdit->setPagetitle(getRequest('ymap_pagetitle'));
		$oOptionsEdit->setEnablescrollzoom(getRequest('ymap_enablescrollzoom')  ? 1 : 0);
		$oOptionsEdit->setShowtoolbar(getRequest('ymap_showtoolbar'));
		$oOptionsEdit->setShowtypecontrol(getRequest('ymap_showtypecontrol')  ? 1 : 0);
		$oOptionsEdit->setShowzoom(getRequest('ymap_showzoom')  ? 1 : 0);
		$oOptionsEdit->setShowsearchcontrol(getRequest('ymap_showsearchcontrol')  ? 1 : 0);
		$oOptionsEdit->setShowsearch(getRequest('ymap_showsearch')  ? 1 : 0);
		/**
		 * Обновляем настройки
		 */
		if ($this->PluginYmap_Ymapoptions_UpdateYmapoptions($oOptionsEdit)) {
			$this->Message_AddNotice($this->Lang_Get('options_edit_submit_save_ok'));

		} else {
			$this->Message_AddError($this->Lang_Get('system_error'));
		}
	}
	
	/**
	 * Обработка отправки формы добавления нового маркера
	 *
	 */
	protected function SubmitAddMarker() {

		/**
		 * Заполняем свойства
		 */
		$oYmap=Engine::GetEntity('PluginYmap_Ymap');
		$oYmap->setActive(getRequest('marker_active') ? 1 : 0);		
		$oYmap->setName(getRequest('marker_name'));
		$oYmap->setLatitude(getRequest('marker_latitude'));
		$oYmap->setLongitude(getRequest('marker_longitude'));
		$oYmap->setCat(getRequest('marker_cat'));
		$oYmap->setAddress(getRequest('marker_address'));
		$oYmap->setPhone(getRequest('marker_phone'));
		$oYmap->setLink(getRequest('marker_link'));
		$oYmap->setImage(getRequest('marker_image'));
		
		/**
		 * Добавляем маркер
		 */		
		if ($this->PluginYmap_Ymap_AddMarker($oYmap)) {
			$this->Message_AddNotice($this->Lang_Get('marker_create_submit_save_ok'));
			$this->SetParam(0,null);
		} else {
			$this->Message_AddError($this->Lang_Get('system_error'));
		}
	}
	
	/**
	 * Обработка отправки формы при редактировании Категории маркеров
	 *
	 * @param unknown_type $oMarkercatEdit
	 */
	protected function SubmitEditMarkercat($oMarkercatEdit) {
		
		/**
		 * Обновляем свойства категории маркеров
		 */		
		
		$oMarkercatEdit->setCatname(getRequest('cat_name'));
		$oMarkercatEdit->setCatstylename(getRequest('cat_stylename'));
		$oMarkercatEdit->setCaticon(getRequest('cat_icon'));
		/**
		 * Обновляем категорию маркеров
		 */
		if ($this->PluginYmap_Ymapcat_UpdateMarkercat($oMarkercatEdit)) {
			$this->Message_AddNotice($this->Lang_Get('cat_edit_submit_save_ok'));
			$this->SetParam(0,null);
			$this->SetParam(1,null);
		} else {
			$this->Message_AddError($this->Lang_Get('system_error'));
		}
	}
	/**
	 * Обработка отправки формы добавления новой категории
	 *
	 */
	protected function SubmitAddMarkercat() {

		/**
		 * Заполняем свойства
		 */
		$oYmapcat=Engine::GetEntity('PluginYmap_Ymapcat');	
		$oYmapcat->setCatname(getRequest('cat_name'));
		$oYmapcat->setCatstylename(getRequest('cat_stylename'));
		$oYmapcat->setCaticon(getRequest('cat_icon'));
		
		/**
		 * Добавляем категорию маркеров
		 */		
		if ($this->PluginYmap_Ymapcat_AddMarkercat($oYmapcat)) {
			$this->Message_AddNotice($this->Lang_Get('cat_create_submit_save_ok'));
			$this->SetParam(0,null);
		} else {
			$this->Message_AddError($this->Lang_Get('system_error'));
		}
	}
	
}
?>