<?php
/*
*	Yandex.Maps plugin for Livestreet CMS
*	Developer: Igor Klochko
*   Contact e-mail: klochko.igor@gmail.com
*/
/**
 * Модуль Яндекс карт
 *
 */
class PluginYmap_ModuleYmap extends Module {		
	protected $oMapper;
	protected $aRebuildIds=array();
		
	/**
	 * Инициализация
	 *
	 */
	public function Init() {		
		$this->oMapper=Engine::GetMapper(__CLASS__);
	}
	/**
	 * Добавляет маркер
	 *
	 * @param YmapEntity_Ymap $oYmap
	 * @return unknown
	 */
	public function AddMarker(PluginYmap_ModuleYmap_EntityYmap $oYmap) {
		if ($sId=$this->oMapper->AddMarker($oYmap)) {			
			$oYmap->setId($sId);
			return true;
		}
		return false;
	}
	/**
	 * Обновляет маркер
	 *
	 * @param YmapEntity_Ymap $oYmap
	 * @return unknown
	 */
	public function UpdateMarker(PluginYmap_ModuleYmap_EntityYmap $oYmap) {
		if ($this->oMapper->UpdateMarker($oYmap)) {
			return true;
		}
		return false;
	}	
	/**
	 * Получает маркер по айдишнику
	 *
	 * @param unknown_type $sId
	 * @return unknown
	 */
	public function GetMarkerById($sId) {
		return $this->oMapper->GetMarkerById($sId);
	}
	/**
	 * Получает список всех маркеров
	 *
	 * @return unknown
	 */
	public function GetMarkers() {
		$aMarkers=array();
		$aMarkersRow=$this->oMapper->GetMarkers();
		if (count($aMarkersRow)) {
			$aMarkers=$this->BuildMarkersList($aMarkersRow);
		}
		return $aMarkers;
	}
	
	/**
	 * Получает список маркеров по фильтру
	 *
	 * @return unknown
	 */
	public function GetMarkersFilter($aFilter) {
		$aMarkers=array();
		$aMarkersRow=$this->oMapper->GetMarkersFilter($aFilter);	
		if (count($aMarerssRow)) {
			$aMarkers=$this->BuildMarkersList($aPagesRow);
		}
		return $aMarkers;
	}
	
	protected function BuildMarkersList($aMarkers,$bBegin=true) {
		static $aResultMarkers;
		if ($bBegin) {
			$aResultMarkers=array();
		}
		foreach ($aMarkers as $aMarker) {
			$aTemp=$aMarker;
			$aResultPages[]=Engine::GetEntity('PluginYmap_Ymap',$aTemp);			
		}
		
		return $aResultPages;
	}

	/**
	 * Удаляет маркер по айдишнику
	 *
	 * @param unknown_type $sId
	 * @return unknown
	 */
	public function deleteMarkerById($sId) {
		if ($this->oMapper->deleteMarkerById($sId)) {
			return true;
		}
		return false;		
	}
	/**
	 * Получает число маркеров
	 *
	 * @return unknown
	 */
	public function GetCountMarker() {
		return $this->oMapper->GetCountMarker();
	}
}
?>