<?php
/*
*	Yandex.Maps plugin for Livestreet CMS
*	Developer: Igor Klochko
*   Contact e-mail: klochko.igor@gmail.com
*/

class PluginYmap_ModuleYmap_MapperYmap extends Mapper {
	
	public function AddMarker(PluginYmap_ModuleYmap_EntityYmap $oYmap) {
		$sql = "INSERT INTO ".Config::Get('plugin.ymap.table.ymap')." 
			(marker_name,
			marker_latitude,
			marker_longitude,
			marker_cat,
			marker_address,
			marker_phone,
			marker_link,
			marker_image,
			marker_active					
			)
			VALUES(?, ?,	?,	?,  ?,  ?,  ?,  ?,  ?d)
		";			
		if ($iId=$this->oDb->query($sql,$oYmap->getName(),$oYmap->getLatitude(),$oYmap->getLongitude(),$oYmap->getCat(),$oYmap->getAddress(),$oYmap->getPhone(),$oYmap->getLink(),$oYmap->getImage(),$oYmap->getActive())) 
		{
			return $iId;
		}		
		return false;
	}
	
	public function UpdateMarker(PluginYmap_ModuleYmap_EntityYmap $oYmap) {
		$sql = "UPDATE ".Config::Get('plugin.ymap.table.ymap')." 
			SET marker_name = ? ,
			marker_latitude = ? ,
			marker_longitude = ? ,
			marker_cat = ? ,
			marker_address = ? ,
			marker_phone = ? ,
			marker_link = ? ,
			marker_image = ? ,
			marker_active	 = ?d		
			WHERE marker_id = ?
		";			
		if ($this->oDb->query($sql,$oYmap->getName(),$oYmap->getLatitude(),$oYmap->getLongitude(),$oYmap->getCat(),$oYmap->getAddress(),$oYmap->getPhone(),$oYmap->getLink(),$oYmap->getImage(),$oYmap->getActive(),$oYmap->getId())) 
		{
			return true;
		}		
		return false;
	}

	public function GetMarkerById($sId) {
		$sql = "SELECT * FROM ".Config::Get('plugin.ymap.table.ymap')." WHERE marker_id = ? ";
		if ($aRow=$this->oDb->selectRow($sql,$sId)) {
			return Engine::GetEntity('PluginYmap_Ymap',$aRow);
		}
		return null;
	}
	
	public function deleteMarkerById($sId) {
		$sql = "DELETE FROM ".Config::Get('plugin.ymap.table.ymap')." WHERE marker_id = ? ";
		if ($aRow=$this->oDb->selectRow($sql,$sId)) {
			return true;
		}
		return false;
	}
	
	public function GetMarkers() {
		$sql = "SELECT 
					*
				FROM 
					".Config::Get('plugin.ymap.table.ymap')." 
				ORDER by marker_cat;	
					";
		if ($aRows=$this->oDb->select($sql)) {
			return $aRows;
		}
		return null;
	}


/*	
	public function GetMarkersFilter($aFilter) {
		$keyword=$aFilter;
		$sql = "SELECT 
					*,					
					marker_id as ARRAY_KEY,
				FROM 
					".Config::Get('plugin.ymap.table.ymap')." 
				WHERE 
					marker_name LIKE '{$keyword}'
				OR	
					marker_address LIKE '{$keyword}'
				OR	
					marker_cat LIKE '{$keyword}'
					{ and page_active = ?d }									
				ORDER by marker_cat desc;	
					";
		if ($aRows=$this->oDb->select($sql) {
			return $aRows;
		}
		return null;
	}
*/	
	public function GetCountMarker() {
		$sql = "SELECT count(*) as count FROM ".Config::Get('plugin.ymap.table.ymap')." ";
		if ($aRow=$this->oDb->selectRow($sql)) {
			return $aRow['count'];
		}
		return null;
	}
	
}
?>