<?php
/*
*	Yandex.Maps plugin for Livestreet CMS
*	Developer: Igor Klochko
*   Contact e-mail: klochko.igor@gmail.com
*/
/**
 * Модуль категорий маркеров Яндекс карт
 *
 */
class PluginYmap_ModuleYmapcat extends Module {		
	protected $oMapperCat;
		
	/**
	 * Инициализация
	 *
	 */
	public function Init() {		
		$this->oMapperCat=Engine::GetMapper(__CLASS__);
	}
	/**
	 * Добавляет категорию
	 *
	 * @param YmapEntity_Ymapcat $oYmapcat
	 * @return unknown
	 */
	public function AddMarkercat(PluginYmap_ModuleYmapcat_EntityYmapcat $oYmapcat) {
		if ($sCatid=$this->oMapperCat->AddMarkercat($oYmapcat)) {			
			$oYmapcat->setCatid($sCatid);
			return true;
		}
		return false;
	}
	/**
	 * Обновляет категорию
	 *
	 * @param YmapEntity_Ymapcat $oYmapcat
	 * @return unknown
	 */
	public function UpdateMarkercat(PluginYmap_ModuleYmapcat_EntityYmapcat $oYmapcat) {
		if ($this->oMapperCat->UpdateMarkercat($oYmapcat)) {
			return true;
		}
		return false;
	}	
	/**
	 * Получает категорию по айдишнику
	 *
	 * @param unknown_type $sCatid
	 * @return unknown
	 */
	public function GetMarkercatById($sCatid) {
		return $this->oMapperCat->GetMarkercatById($sCatid);
	}
	/**
	 * Получает список всех категорий
	 *
	 * @return unknown
	 */
	public function GetMarkercats() {
		$aMarkercats=array();
		$aMarkercatsRow=$this->oMapperCat->GetMarkercats();
		if (count($aMarkercatsRow)) {
			$aMarkercats=$this->BuildMarkercatsList($aMarkercatsRow);
		}
		return $aMarkercats;
	}
	
	protected function BuildMarkercatsList($aMarkercats,$bBegin=true) {
		static $aResultMarkercats;
		if ($bBegin) {
			$aResultMarkercats=array();
		}
		foreach ($aMarkercats as $aMarkercat) {
			$aTemp=$aMarkercat;
			$aResultMarkercats[]=Engine::GetEntity('PluginYmap_Ymapcat',$aTemp);
		}
		
		return $aResultMarkercats;
	}

	/**
	 * Удаляет категорию по айдишнику
	 *
	 * @param unknown_type $sCatid
	 * @return unknown
	 */
	public function deleteMarkercatById($sCatid) {
		if ($this->oMapperCat->deleteMarkercatById($sCatid)) {
			return true;
		}
		return false;		
	}
	/**
	 * Получает число категорий
	 *
	 * @return unknown
	 */
	public function GetCountMarkercat() {
		return $this->oMapperCat->GetCountMarkercat();
	}
}
?>