<?php
/*
*	Yandex.Maps plugin for Livestreet CMS
*	Developer: Igor Klochko
*   Contact e-mail: klochko.igor@gmail.com
*/
class PluginYmap_ModuleYmapcat_MapperYmapcat extends Mapper {
	
	public function AddMarkercat(PluginYmap_ModuleYmapcat_EntityYmapcat $oYmapcat) {
		$sql = "INSERT INTO ".Config::Get('plugin.ymap.table.ymapcat')." 
			(cat_name,
			 cat_stylename,
			cat_icon				
			)
			VALUES(?, ?, ?)
		";			
		if ($iCatid=$this->oDb->query($sql,$oYmapcat->getCatname(),$oYmapcat->getCatstylename(),$oYmapcat->getCaticon())) 
		{
			return $iCatid;
		}		
		return false;
	}
	
	public function UpdateMarkercat(PluginYmap_ModuleYmapcat_EntityYmapcat $oYmapcat) {
		$sql = "UPDATE ".Config::Get('plugin.ymap.table.ymapcat')." 
			SET cat_name = ? ,
			cat_stylename	 = ?,
			cat_icon	 = ?		
			WHERE cat_id = ?d
		";			
		if ($this->oDb->query($sql,$oYmapcat->getCatname(),$oYmapcat->getCatstylename(),$oYmapcat->getCaticon(),$oYmapcat->getCatid())) 
		{
			return true;
		}		
		return false;
	}

	public function GetMarkercatById($sCatid) {
		$sql = "SELECT * FROM ".Config::Get('plugin.ymap.table.ymapcat')." WHERE cat_id = ? ";
		if ($aRow=$this->oDb->selectRow($sql,$sCatid)) {
			return Engine::GetEntity('PluginYmap_Ymapcat',$aRow);
		}
		return null;
	}
	
	public function deleteMarkercatById($sCatid) {
		$sql = "DELETE FROM ".Config::Get('plugin.ymap.table.ymapcat')." WHERE cat_id = ? ";
		if ($aRow=$this->oDb->selectRow($sql,$sCatid)) {
			return true;
		}
		return false;
	}
	
	public function GetMarkercats() {
		$sql = "SELECT 
					*
				FROM 
					".Config::Get('plugin.ymap.table.ymapcat')." 
				ORDER by cat_id asc;	
					";
		if ($aRows=$this->oDb->select($sql)) {
			return $aRows;
		}
		return null;
	}
	
	public function GetCountMarkercat() {
		$sql = "SELECT count(*) as count FROM ".Config::Get('plugin.ymap.table.ymapcat')." ";
		if ($aRow=$this->oDb->selectRow($sql)) {
			return $aRow['count'];
		}
		return null;
	}
	
}
?>